SystemOrganization addCategory: #'ChronosSystem-Squeak'!

!Number methodsFor: '*chronossystem-squeak' stamp: 'PaulDeBruicker 3/9/2011 14:50'!
year
	^Duration days: self * 365! !

!Number methodsFor: '*chronossystem-squeak' stamp: 'PaulDeBruicker 3/9/2011 14:51'!
years
	^CalendarDuration days: (self * 365)! !

ChronosEnvironment subclass: #ChronosSqueakEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'ChronosSystem-Squeak'!

!ChronosSqueakEnvironment class methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/18/2006 14:41'!
chronosNamespace
	"Answer the namespace that contains the classes of the Chronos codebase."

	^self globalNamespace at: self chronosNamespaceName! !

!ChronosSqueakEnvironment class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 09:32'!
defineChronosNamespaces
	"self defineChronosNamespace.
	self defineChronosTemporalRatioConstantsNamespace.
	self defineChronosDaysOfWeekConstantsNamespace.
	self defineChronosStandardMonthConstantsNamespace.
	self defineChronosFactoryBindingsNamespace.
	self defineChronosCalendarConstantsNamespace.
	self defineChronosDurationConstantsNamespace.
	self defineChronosConstantsNamespace."! !

!ChronosSqueakEnvironment class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 12:21'!
defineChronosSharedAndGlobalVariables
"Most of this is taken care of in the ChronosConstants class initialization method.  "
	self defineChronosGlobalsAndAliases! !

!ChronosSqueakEnvironment class methodsFor: 'private' stamp: 'PaulDeBruicker 12/6/2011 21:02'!
setPlatformClass
	PlatformClass := self! !

!ChronosSqueakEnvironment class methodsFor: 'private' stamp: 'Alan Lovejoy 3/19/2006 21:21'!
setProtectedGlobalVariables
    ProtectedGlobalVariables := Set with: #ScaledDecimal with: #DateAndTime with: #Duration! !

!ChronosSqueakEnvironment class methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/19/2006 21:22'!
systemFacadeClass
	^ ChronosSqueakSystemFacade ! !

!ChronosSqueakEnvironment methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:28'!
initializeDurationConstants
	"ChronosEnvironment canonical initializeDurationConstants"


	ScientificDuration initializeClassVariables.
	CalendarDuration initializeClassVariables.
	ChronosConstants assignChronosDurationConstants.
	! !

!ChronosSqueakEnvironment methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:30'!
initializeFactoryBindings
	
	ChronosConstants assignChronosFactoryBindings.
	! !

!ChronosSqueakEnvironment methodsFor: 'installation/setup' stamp: 'PaulDeBruicker 3/9/2011 12:35'!
install


	super install.! !

!ChronosSqueakEnvironment methodsFor: 'installation/setup' stamp: 'PaulDeBruicker 3/9/2011 12:33'!
setAnsiStandardCalendar: aGregorianCalendar
 ChronosConstants setAnsiStandardCalendar: aGregorianCalendar   ! !

!ChronosSqueakEnvironment methodsFor: 'installation/setup' stamp: 'PaulDeBruicker 3/9/2011 12:33'!
setAnsiStandardCalendarClock: aGregorianCalendarClock

	ChronosConstants setAnsiStandardCalendarClock: aGregorianCalendarClock   ! !

!ChronosSqueakEnvironment methodsFor: 'installation/setup' stamp: 'PaulDeBruicker 3/9/2011 12:31'!
setGregorian: aGregorianCalendar

	ChronosConstants setGregorian: aGregorianCalendar   ! !

!ChronosSqueakEnvironment methodsFor: 'installation/setup' stamp: 'PaulDeBruicker 3/9/2011 12:32'!
setJulian: aJulianCalendar

ChronosConstants setJulian: aJulianCalendar   ! !

ChronosSystemClock subclass: #ChronosSqueakSystemClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'ChronosSystem-Squeak'!

!ChronosSqueakSystemClock methodsFor: 'testing' stamp: 'Alan Lovejoy 3/19/2006 21:14'!
isRelativeToUT
	"If the receiver reports ticks relative to UT, answer true.
	If the receiver reports ticks relative to local time, answer false."

	^false! !

!ChronosSqueakSystemClock methodsFor: 'API-timing' stamp: 'Alan Lovejoy 3/18/2006 21:40'!
nanosecondsToRun: timedBlock
	^ChronosFunction times1000000: (Time millisecondsToRun: timedBlock)! !

!ChronosSqueakSystemClock methodsFor: 'calendar clock binding' stamp: 'Alan Lovejoy 3/19/2006 21:15'!
secondsFromGregorianEpochUpToSystemClockEpoch
	"Answer the number of seconds from the Epoch date/time of the Proleptic Gregorian Calendar (i.e., January 1, 1 AD  00:00:00 Proleptic Gregorian) up to the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where clock ticks = 0).  For most Smalltallk implementations, the platform system clock is a software device provided by the virtual machine.  On most operating systems, the system clock's zero point will be 00:00:00 UT of the first day of some Gregorian year.  However, some platforms (e.g., Microsoft Windows) use a zero point that is 00:00:00 (midnight) LOCAL TIME.  Do not adjust the encapsulated clock's tick count from UT to local time, nor from local time to UT.  If the encapsulated clock reports ticks relative to UT, then #secondsFromGregorianEpochUpToSystemClockEpoch should answer the number of seconds since midnight UT of the clock's epoch date, and the instance method #isRelativeToUT should answer true. However, if the encapsulated clock reports ticks relative to local time, then #secondsFromGregorianEpochUpToSystemClockEpoch should answer the number of seconds since midnight local time of the clock's epoch date, and the instance method #isRelativeToUT should answer false.

	See the comment for the same method in ChronosSystemClock for help in porting to other systems, or for help in converting to/from foreign system clocks."

	"^Calendar gregorian secondsSinceEpochUpToYear: 1901" ^59958144000! !

!ChronosSqueakSystemClock methodsFor: 'API-timing' stamp: 'PaulDeBruicker 3/17/2011 18:43'!
ticksNowSinceSystemClockEpoch
	"Answer the number of seconds since 00:00 on the morning of
	 January 1, 1901 (a 32-bit unsigned number).
	 Essential. See Object documentation whatIsAPrimitive. "

	<primitive: 137>
	self primitiveFailed! !

ChronosSystemFacade subclass: #ChronosSqueakSystemFacade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'ChronosSystem-Squeak'!

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 10:46'!
chronosDateAndTimeFromNativeCalendricalCoordinate: aNativeCalendricalCoordinate calendarClock: calendarClock 
	"Answer a Chronos DateAndTime that semantically corresponds as closely as possible to <aNativeTimestampOrDate>."

	"{ChronosSystemFacade current chronosDateAndTimeFromNativeCalendricalCoordinate: DateAndTime now calendarClock: Calendar gregorian clock}
	{ChronosSystemFacade current chronosDateAndTimeFromNativeCalendricalCoordinate: DateAndTime now calendarClock: Calendar julian clock}
	{ChronosSystemFacade current chronosDateAndTimeFromNativeCalendricalCoordinate: Date today calendarClock: Calendar julian clock}
	{ChronosSystemFacade current chronosDateAndTimeFromNativeCalendricalCoordinate: Date today calendarClock: Calendar gregorian clock}"

	| timepoint |
	
	timepoint := 
		DateAndTimeFactory basicNew
			setCalendar: calendarClock calendar;
			setJulianDayNumber: aNativeCalendricalCoordinate julianDayNumber.
 	^((aNativeCalendricalCoordinate respondsTo: #nanoSecond) 
		ifTrue: 
			[timepoint
				basicSetTimeZone: (self chronosDurationFromNativeDuration: aNativeCalendricalCoordinate offset) asTimezone;
				setHour: aNativeCalendricalCoordinate hour minute: aNativeCalendricalCoordinate minute second: aNativeCalendricalCoordinate second;
				setNanosecondsSinceSecond: aNativeCalendricalCoordinate nanoSecond]
		ifFalse: 
			[timepoint
				setSecondsSinceStartOfDay: 0;
				setNanosecondsSinceSecond: 0]) 
					canonicalizeFromLocalTime;
					beImmutable
! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 03:37'!
chronosDateFromNativeCalendricalCoordinate: aNativeCalendricalCoordinate calendarClock: calendarClock 
	"Answer a Chronos date value that semantically corresponds as closely as possible to <aNativeTimestampOrDate>."

	"{ChronosSystemFacade current chronosDateFromNativeCalendricalCoordinate: DateAndTime now calendarClock: Calendar gregorian clock}
	{ChronosSystemFacade current chronosDateFromNativeCalendricalCoordinate: DateAndTime now calendarClock: Calendar julian clock}
	{ChronosSystemFacade current chronosDateFromNativeCalendricalCoordinate: Date today calendarClock: Calendar julian clock}
	{ChronosSystemFacade current chronosDateFromNativeCalendricalCoordinate: Date today calendarClock: Calendar gregorian clock}"

	| calendar |
	calendar := calendarClock calendar.
	^calendar isGregorian 
		ifTrue: 
			[DateFactory 
				year: aNativeCalendricalCoordinate year
				day: aNativeCalendricalCoordinate day]
		ifFalse: 
			[DateFactory  
				julianDay: aNativeCalendricalCoordinate julianDayNumber
				calendar: calendar]! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 10:46'!
chronosDurationFromNativeDuration: aNativeDuration 
	"Answer a ScientificDuration that semantically corresponds as closely as possible to <aNativeDuration>."

	"ChronosSystemFacade current chronosDurationFromNativeDuration: (Duration hours: -8)"

	^DurationFactory seconds: aNativeDuration asSeconds nanoseconds: aNativeDuration nanoSeconds! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 02:50'!
chronosTimeOfDayFromNativeTimeOfDay: aNativeTimeOfDay 
	"Answer a Chronos TimeOfDay that semantically corresponds as closely as possible to <aNativeTimeOfDay>."

	^TimeOfDayFactory 
		hour: aNativeTimeOfDay hours
		minute: aNativeTimeOfDay minutes
		second: aNativeTimeOfDay seconds! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'PaulDeBruicker 3/9/2011 10:38'!
chronosTimezoneFromNativeTimeZone: aNativeTimeZone 
	"Answer a ChronosTimezone that semantically corresponds as closely as possible to <aNativeTimeZone>."
	"ChronosSystemFacade current chronosTimezoneFromNativeTimeZone: TimeZone default"

	| offsetSecondsFromUT |
	offsetSecondsFromUT := aNativeTimeZone offset asSeconds.
	^offsetSecondsFromUT = 0
		ifTrue: [ChronosTimezone universal]
		ifFalse: [((DurationFactory) seconds: offsetSecondsFromUT nanoseconds: aNativeTimeZone offset nanoSeconds) asTimezone]! !

!ChronosSqueakSystemFacade methodsFor: 'private-system timezone' stamp: 'Alan Lovejoy 3/19/2006 22:02'!
defaultSystemTimeZoneBindingStrategy
	"Answer the strategy that Chronos should use by default whenever Chronos attempts resolve the Chronos system timezone based on the local timezone of the host system and/or Smalltalk execution environment. See class comment for a full explanation of the options.  This default can be overridden by sending control messages to the receiver."

	^#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone

	"Options: 
		#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
		#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone 
		#setSystemTimeZoneToAnalogOfNativeSystemTimeZone"! !

!ChronosSqueakSystemFacade methodsFor: 'testing' stamp: 'Alan Lovejoy 3/19/2006 21:43'!
isChronologyLibraryResident
	^Smalltalk includesKey: #TimeZone! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 03:25'!
nativeCalendricalCoordinateFromChronosDate: aChronosDate
	"Answer the native 'Date' analog (or 'Timestamp' analog, if no Date analog is available) that semantically corresponds as closely as possible to <aChronosDate>"

	"{ChronosSystemFacade current  nativeCalendricalCoordinateFromChronosDate: Gregorian clock dateToday}"
	"{ChronosSystemFacade current  nativeCalendricalCoordinateFromChronosDate: Julian clock dateToday}"

	^Date julianDayNumber: aChronosDate julianDayNumber! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 10:47'!
nativeCalendricalCoordinateFromChronosDateAndTime: aChronosDateAndTime 
	"Answer the native 'Timestamp' analog (or 'Date' analog, if no Timestamp analog is available) that semantically corresponds as closely as possible to <aChronosDateAndTime>"

	"{ChronosSystemFacade current  nativeCalendricalCoordinateFromChronosDateAndTime: Gregorian clock now}"
	"{ChronosSystemFacade current  nativeCalendricalCoordinateFromChronosDateAndTime: Julian clock now}"

	^DateAndTime
		year: aChronosDateAndTime year 
		month: aChronosDateAndTime month 
		day: aChronosDateAndTime dayOfMonth 
		hour: aChronosDateAndTime hour 
		minute: aChronosDateAndTime minute 
		second: aChronosDateAndTime second 
		nanoSecond: aChronosDateAndTime nanosecondsSinceSecond 
		offset: (self navitiveDurationFromChronosDuration: aChronosDateAndTime offset)! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 02:49'!
nativeTimeOfDayFromChronosTimeOfDay: aChronosTimeOfDay
	"Answer the native 'TimeOfDay' analog that semantically corresponds as closely as possible to <aChronosTimeOfDay>"

	"{ChronosSystemFacade current  nativeTimeOfDayFromChronosTimeOfDay: Gregorian clock timeOfDayNow}"

	^Time fromSeconds: aChronosTimeOfDay secondsSinceStartOfDay! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 10:47'!
nativeTimeZoneFromChronosTimeZone: aChronosTimezone
	"Answer the native time zoneanalog that semantically corresponds as closely as possible to <aChronosTimezone>. If there is no such value, or if Chronos is the native date/time library of the host environment, answer <aChronosTimezone>."

	| boundTZ |
	boundTZ := aChronosTimezone now timeZone. "We assume that the offset and abbreviation in effect as of the current moment are probably the best ones to use."
	^TimeZone 
		offset: (self navitiveDurationFromChronosDuration: boundTZ offsetFromUT) 
		name: self systemTimeZone name asString
		abbreviation: boundTZ commonAbbreviation! !

!ChronosSqueakSystemFacade methodsFor: 'value conversion' stamp: 'Alan Lovejoy 3/19/2006 10:47'!
navitiveDurationFromChronosDuration: aScientificDuration 
	"Answer a ScientificDuration that semantically corresponds as closely as possible to <aNativeDuration>."

	"ChronosSystemFacade current navitiveDurationFromChronosDuration: (DurationFactory hours: -8)"

	^Duration seconds: aScientificDuration asSeconds nanoSeconds: aScientificDuration nanosecondsSinceSecond! !

!ChronosSqueakSystemFacade methodsFor: 'instance creation' stamp: 'Alan Lovejoy 3/19/2006 21:10'!
newSystemClock
	^ChronosSqueakSystemClock new! !

!ChronosSqueakSystemFacade methodsFor: 'private-system timezone' stamp: 'Alan Lovejoy 3/19/2006 21:43'!
setBaseSystemTimeZoneFromChronosSystemTimeZone
	"Set the base system's timezone (that defines its local time) to one which is as congruent as possible to the receiver's <systemTimeZone>.  This operation MUST NOT affect how time is reported by Chronos. If the Smalltalk execution environment has its own support for timezones (apart from either Chronos or the operating system,) then this operation should affect how the current Smalltalk execution environment reports time using its native date-time facilities.  Ideally, this operation should also affect the reporting of time by the host operating system (at least for the current user, but probably not for all users.) 

	NOTE: Some systems keep time in UT, and report local time by converting from UT according to the specifications of the current timezone.  Other systems keep time in local terms, and convert to UT when needful according to the specifications of the current timezone.  In the former case, this operation optimally should change the local time-of-day natively reported by the Smalltalk execution environment.  In the latter case, it should change the UT time-of-day natively reported by the Smalltalk execution environment."

	self isChronologyLibraryResident ifFalse: [^self "TimeZone not present pre 3.7, so do nothing for now"].

	"The following logic only works for time zones with no DST transitions.  There is no other option, since Chronology.TimeZone doesn't do DST transitions--an issue which is someone else's problem to solve, not mine..."

	DateAndTime localTimeZone: (self nativeTimeZoneFromChronosTimeZone: self systemTimeZone)! !

!ChronosSqueakSystemFacade methodsFor: 'private-system timezone' stamp: 'Alan Lovejoy 3/19/2006 21:59'!
setSystemTimeZoneToAnalogOfNativeSystemTimeZone
	"If it's possible to determine that the host system is using an Olson timezone to define its local time, and if it's also possible to determine the Olson key of that timezone (to the desired degreee of certainty and precision,) then set the receiver's <systemTimeZone> to a Chronos VariableOffsetTimezone with the same key and answer true.

	Otherwise, construct a ChronosTimezone that emulates the behavior of the host system's timezone as closely as possible (i.e., serves a reasonably close analog of the host system's timezone,) set the ChronosTimezone so constructed as the <systemTimeZone> and answer true. However, if it's not possible to get sufficient information about the host system's timezone to construct a ChronosTimezone that will serve as a reasonable analog, then do nothing and answer false."

	"{ChronosSystemFacade current setSystemTimeZoneToAnalogOfNativeSystemTimeZone}"

	| success |
	success := super setSystemTimeZoneToAnalogOfNativeSystemTimeZone.
	success ifTrue: [^true].
	^self isChronologyLibraryResident
		ifTrue: 
			[self setSystemTimeZone:  (self chronosTimezoneFromNativeTimeZone: DateAndTime localTimeZone).
			true]
		ifFalse: [false]! !

!ChronosSqueakSystemFacade methodsFor: 'private-system timezone' stamp: 'Alan Lovejoy 3/19/2006 21:58'!
setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
	"Determine the key of the Olson timezone that is the most congruent to the host system's timezone, set the <systemTimeZone> to the ChronosTimezone with that key, and answer true. However, if it is not possible to obtain enough information about the host system's timezone to determine the Olson timezone key of the Olson timezone that would be reasonably congruent to the host system's timezone, then do nothing and answer false."

	| success nativeTimeZone timeZoneKey |
	success := super setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem.
	success ifTrue: [^true].
	self isChronologyLibraryResident ifFalse: [^false].

	"So, we have to use the Chronology TimeZone information. We'll attempt to map first the abbreviation then the 'offset' to an Olson timezone key using the default TimeZoneLocalizationPolicy."

	nativeTimeZone := DateAndTime localTimeZone.
	timeZoneKey := 
		TimeZoneLocalizationPolicy default 
			defaultTimeZoneKeyWithCommonAbbreviation: nativeTimeZone abbreviation
			dstPreferred: true 
			ifAbsent:
				[TimeZoneLocalizationPolicy default 
					defaultTimeZoneKeyForStandardTimeOffsetSecondsFromUT: nativeTimeZone offset asSeconds
					dstPreferred: false
					ifAbsent: []].
	^timeZoneKey == nil
		ifTrue: [false]
		ifFalse:
			[self setSystemTimeZone:  (VariableOffsetTimezone at: timeZoneKey ifAbsent: [^false]).
			true]
! !
